diff a/src/hotspot/share/gc/parallel/psParallelCompact.cpp b/src/hotspot/share/gc/parallel/psParallelCompact.cpp
--- a/src/hotspot/share/gc/parallel/psParallelCompact.cpp
+++ b/src/hotspot/share/gc/parallel/psParallelCompact.cpp
@@ -1110,10 +1110,14 @@
   //
   // Need to fill in the gap only if it's smaller than min-obj-size, and the
   // filler obj will extend to next region.
 
   // Note: If min-fill-size decreases to 1, this whole method becomes redundant.
+  if (UseCompactObjectHeaders) {
+    // The gap is always equal to min-fill-size, so nothing to do.
+    return;
+  }
   assert(CollectedHeap::min_fill_size() >= 2, "inv");
 #ifndef _LP64
   // In 32-bit system, each heap word is 4 bytes, so MinObjAlignment == 2.
   // The gap is always equal to min-fill-size, so nothing to do.
   return;
